background = Image.load("background.png")
background1 = Image.load("background1.png")
y = 230
x = 20
black = Color.new(0,0,0)

--define globals
PLAYER_HEIGHT = 32
PLAYER_WIDTH = 24

jump1 = 1
jump2 = 1

dir = {}
dir.vx = 0
dir.vy = 0
dir.ax = 0
dir.ay = 1  --constant gravity

W_FRAME = 1
W_TIMER = 4
J_FRAME = 1
J_TIMER = 4

SCROLLX = 0
SCROLLY = 0

--Collision colors
Solid_Ground = Color.new(0,255,255)
Semi_Solid_Ground = Color.new(255,255,0)
Air = Color.new(255,255,255)


--Load Ryu Sprites

--Lefts
Stand_l = Image.load("ryu_l/stand.png")
Run_l = {}
Run_l[1] = Image.load("ryu_l/run1.png")
Run_l[2] = Image.load("ryu_l/run2.png")
Run_l[3] = Image.load("ryu_l/run3.png")
SideJump_l = {}
SideJump_l[1] = Image.load("ryu_l/sidejump1.png")
SideJump_l[2] = Image.load("ryu_l/sidejump2.png")
SideJump_l[3] = Image.load("ryu_l/sidejump3.png")
SideJump_l[4] = Image.load("ryu_l/sidejump4.png")
Jump_l = {}
Jump_l[0] = Image.load("ryu_l/jump0.png")
Jump_l[1] = Image.load("ryu_l/jump1.png")

--Rights
Stand_r = Image.load("ryu_r/stand.png")
Run_r = {}
Run_r[1] = Image.load("ryu_r/run1.png")
Run_r[2] = Image.load("ryu_r/run2.png")
Run_r[3] = Image.load("ryu_r/run3.png")
SideJump_r = {}
SideJump_r[1] = Image.load("ryu_r/sidejump1.png")
SideJump_r[2] = Image.load("ryu_r/sidejump2.png")
SideJump_r[3] = Image.load("ryu_r/sidejump3.png")
SideJump_r[4] = Image.load("ryu_r/sidejump4.png")
Jump_r = {}
Jump_r[0] = Image.load("ryu_r/jump0.png")
Jump_r[1] = Image.load("ryu_r/jump1.png")

state = Stand_l

function collision()

	while(background:pixel(x + 12,y + 33) == Solid_Ground and background:pixel(x + 12,y + 32) == Solid_Ground) do
		OnGround = 1
		jump1 = 1
		jump2 = 1
		y = y - 1
	end
		
	while(background:pixel(x + 12,y + 33) == Semi_Solid_Ground and background:pixel(x + 12,y + 32) == Semi_Solid_Ground and dir.vy >= 0) do
		OnGround = 1
		jump1 = 1
		jump2 = 1
		y = y - 1
	end

	while(background:pixel(x + 12,y + 33) == Semi_Solid_Ground and background:pixel(x + 12,y + 32) ~= Semi_Solid_Ground) do
		OnGround = 1
		jump1 = 1
		jump2 = 1
		y = y + 2
	end

	if(background:pixel(x + 12,y + 32) == Air and background:pixel(x + 12,y + 33) == Air) then
		OnGround = 0
	end
end
	

function input()
	pad = Controls.read()

	if lastdir == "left"  then
		state = Stand_l
	end
	
	if lastdir == "right"  then
		state = Stand_r
	end

	if(OnGround == 1) then
		if pad:right()  then
			dir.ax = 3
			state = Run_r[W_FRAME]
			W_TIMER = W_TIMER - 1
			if W_TIMER == 0  then
				W_FRAME = W_FRAME + 1
				W_TIMER = 4
			end
			if W_FRAME == 4  then
				W_FRAME = 1
			end
			lastdir = "right"
			if pad:cross()  then
				dir.vy = -13
				y = y - 2
				jump1 = 0
			end
		end

		if pad:left()  then
			dir.ax = -3
			state = Run_l[W_FRAME]
			W_TIMER = W_TIMER - 1
			if W_TIMER == 0  then
				W_FRAME = W_FRAME + 1
				W_TIMER = 4
			end
			if W_FRAME == 4  then
				W_FRAME = 1
			end
			lastdir = "left"
			if pad:cross()  then
				dir.vy = -13
				y = y - 2
				jump1 = 0
			end
		end
		
		if pad:cross()  then
			dir.vy = -10
			y = y - 3
			jump1 = 0
		end
	end

	if(OnGround == 0)  then
		if(lastdir == "left" and dir.vx == 0)  then
			state = Jump_l[0]
			if(dir.vy > -7)  then
				state = Jump_l[1]
			end
		end

		if(lastdir == "right" and dir.vx == 0)  then
			state = Jump_r[0]
			if(dir.vy > -7)  then
				state = Jump_r[1]
			end
		end


		if(lastdir == "left" and dir.vx < 0)  then
			state = SideJump_l[J_FRAME]
			J_TIMER = J_TIMER - 1
			if J_TIMER == 0  then
				J_FRAME = J_FRAME + 1
				J_TIMER = 4
			end
			if J_FRAME == 4  then
				J_FRAME = 1
			end
		end

		if(lastdir == "right" and dir.vx > 0)  then
			state = SideJump_r[J_FRAME]
			J_TIMER = J_TIMER - 1
			if J_TIMER == 0  then
				J_FRAME = J_FRAME + 1
				J_TIMER = 4
			end
			if J_FRAME == 4  then
				J_FRAME = 1
			end
		end
	end

end
function movement()
	
	dir.vx = dir.vx + dir.ax
	dir.vy = dir.vy + dir.ay
	if(dir.vy >= 5)  then
		dir.vy = 4
	end

	dir.ax = 0
	if(OnGround == 1)  then
		x = x + dir.vx
		dir.vx = 0
		dir.vy = 0
	end
	if(OnGround == 0)  then
		y = y + 2
		y = y + dir.vy
		x = x + dir.vx
	end
end

function draw()
	screen:blit(x,y,state)
end




while true do
	screen:blit(0,0,background1)
	screen:blit(0,0,background)

	screen:fillRect(200,130,50,50,background:pixel(x + 12,y + 33))

	input()
	collision()
	movement()
	draw()

	screen.waitVblankStart()
	screen.flip()
end